#include<bits/stdc++.h>
#include <unistd.h>

#define REP(i, n) for(int i = 0; i < n; i++)

using namespace std;

struct data{
	int n;
	int m;
	int k;
	vector<bool> zat;
	vector<vector<int>> e;
};

int rnd(int a, int b){
	return a + (rand() % (b-a+1));
}


vector<int> generate_random_sequence(int minn, int k, int n){
	vector<int> res;
	for(int i = 0; i < n; i++){
		res.push_back(rnd(minn, k));
	}
	return res;
}


// http://www.concentric.net/~Ttwang/tech/inthash.htm
// Workaround kvuli seedu na srand - proces se spousti mnohokrat za sekundu
unsigned long mix(unsigned long a, unsigned long b, unsigned long c)
{
    a=a-b;  a=a-c;  a=a^(c >> 13);
    b=b-c;  b=b-a;  b=b^(a << 8);
    c=c-a;  c=c-b;  c=c^(b >> 13);
    a=a-b;  a=a-c;  a=a^(c >> 12);
    b=b-c;  b=b-a;  b=b^(a << 16);
    c=c-a;  c=c-b;  c=c^(b >> 5);
    a=a-b;  a=a-c;  a=a^(c >> 3);
    b=b-c;  b=b-a;  b=b^(a << 10);
    c=c-a;  c=c-b;  c=c^(b >> 15);
    return c;
}


data generate_diamonds(int n, int k){
	vector<bool> zat(n, false);
	vector<vector<int>> e(n);

	int minus = (n<20 ? 4 : 10);

	int d = (n-minus)/3;
	int m = 0;

	REP(j, d){
		int i = 3*j;
		e[i].push_back(i+1);
		e[i].push_back(i+2);
		e[i+1].push_back(i);
		e[i+2].push_back(i);
		e[i+1].push_back(i+3);
		e[i+2].push_back(i+3);
		e[i+3].push_back(i+1);
		e[i+3].push_back(i+2);
		m+=4;
		zat[i+1]=true;
	}

	zat[n-1] = true;

	for(int i = 3*d; i < n-1; ++i){
		if(n-i-1<=k)zat[i]=true;
		e[i].push_back(i+1);
		e[i+1].push_back(i);
		++m;
	}

	return data{n, m, k, zat, e};
}

// k ... delka tycky
data generate_lollipop(int n, int k){
	//cerr << "Bacha na pocet hran" << endl;

	--k;
	vector<bool> zat(n, true);
	int m = 0;
	vector<vector<int>> e(n);

	REP(i, n-k){
		REP(j, n-k)if(i!=j){
			e[i].push_back(j);
			if(i<j)++m;
		}
	}
	for(int i = n-k-1; i < n-1; ++i){
		e[i].push_back(i+1);
		e[i+1].push_back(i);
		++m;
	}

	return data{n, m, k+1, zat, e};
}


data generate_kaluze(int n, int k){
	assert(n > 2*k+6);

	vector<bool> zat(n, false);
	int m = 0;
	vector<vector<int>> e(n);
	zat[1]=true;
	zat[n-k-1]=true;

	REP(i, k+2){
		++m;
		e[i].push_back(i+1);
		e[i+1].push_back(i);
	}
	e[k+2].push_back(n-1);
	e[n-1].push_back(k+2);
	++m;

	e[0].push_back(k+3);
	e[k+3].push_back(0);
	++m;

	for(int i =k+3; i < n-1; ++i){
		++m;
		e[i].push_back(i+1);
		e[i+1].push_back(i);
	}

	return data{n, m, k, zat, e};

}


// k bych dal okolo n/20
data generate_anti_blowup(int n, int k){
	int d = (n-2)/4;

	vector<bool> zat(n, false);
	int m = 0;
	vector<vector<int>> e(n);

	REP(j, d){
		int i = 4*j;
		e[i].push_back(i+1);
		e[i+1].push_back(i);

		e[i+1].push_back(i+2);
		e[i+2].push_back(i+1);

		e[i].push_back(i+3);
		e[i+3].push_back(i);

		e[i+3].push_back(i+4);
		e[i+4].push_back(i+3);

		e[i+4].push_back(i+2);
		e[i+2].push_back(i+4);

		m+=5;
		zat[i+3]=true;
	}

	for(int i = 4*d; i < n-1; ++i){
		++m;
		e[i].push_back(i+1);
		e[i+1].push_back(i);
	}

	return data{n, m, k, zat, e};
}

data generate_random(int n, int k, int m, int z){

	vector<bool> zat(n, false);
	int mm = 0;
	vector<set<int>> ee(n);

	assert(z <= n);

	while(mm < m){
		int a = rnd(0,n-1);
		int b = rnd(0,n-1);
		if(a==b || ee[a].find(b) != ee[a].end())continue;
		ee[a].insert(b);
		ee[b].insert(a);
		++mm;
	}

	vector<vector<int> > e(n);
	REP(i, n)e[i] = vector<int>(ee[i].begin(), ee[i].end());

	int zz = 0;
	while(zz < z){
		int x = rnd(0,n-1);
		if(zat[x])continue;
		zat[x]=true;
		++zz;
	}

	return data{n, m, k, zat, e};

}


data generate_zatopeny_prvni(int k){
	int n = k+2;
	int m = k+1;
	vector<bool> zat(n, false);
	zat[0]=true;
	vector<vector<int>> e(n);

	REP(i, n-1){
		e[i].push_back(i+1);
		e[i+1].push_back(i);
	}
	return data{n, m, k, zat, e};
}


void print_data(data d){
	cout << d.n << " " << d.m << " " << d.k << endl;
	REP(i, d.n){
		if(i>0)cout << " ";
		cout << (d.zat[i] ? 1 : 0);
	}
	cout << endl;
	REP(i, d.n) for(auto w : d.e[i]) if(i < w) cout << i << " " << w << endl;
}



int main(int argc, char ** argv){
	

	vector<string> args(argv+1, argv+argc);
	int n = stoi(args[0]);
	int k = stoi(args[1]);

	unsigned long seed1 = stoi(args[2]);
	unsigned long seed2 = stoi(args[3]);


	unsigned long seed = mix(seed1, 4742, seed2*n);
	//cerr << seed << endl;
	srand(seed);

	char type = args[4][0];
	assert(type == 'd' || type=='l' || type=='k' || type=='b' || type=='r' || type=='z');

	data d;
	if(type == 'd')
		d = generate_diamonds(n, k);
	if(type == 'l')
		d = generate_lollipop(n, k);
	if(type == 'k')
		d = generate_kaluze(n, k);
	if(type == 'b')
		d = generate_anti_blowup(n, k);
	if(type == 'z')
		d = generate_zatopeny_prvni(k);
	if(type == 'r'){
		int m = stoi(args[5]);
		int z = stoi(args[6]);
		d = generate_random(n, k, m, z);
	}

	print_data(d);
}